%global driver Cisco
%global srcname networking_cisco
%global package_name networking-cisco
%global docpath doc/build/html

%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

Name:           python-%{package_name}
Version:        2015.1.0
Release:        6%{?dist}
Summary:        %{driver} OpenStack Neutron driver

License:        ASL 2.0
URL:            https://pypi.python.org/pypi/%{package_name}
Source0:        https://pypi.python.org/packages/source/n/%{package_name}/%{package_name}-%{upstream_version}.tar.gz
Source1:        neutron-cisco-cfg-agent.service

# patches_base=+2
Patch0001: 0001-Revert-forcing-formatting-of-setup.cfg-to-match-setu.patch
Patch0002: 0002-Sync-notification-to-VSM-major-sync-refactoring.patch
Patch0003: 0003-Bump-minor-version-number-to-enable-development.patch
Patch0004: 0004-s-stackforge-openstack-g.patch
Patch0005: 0005-N1Kv-Force-syncing-BDs-on-neutron-restart.patch
Patch0006: 0006-Moved-N1kv-section-from-neutron-tree-to-stackforge.patch
Patch0007: 0007-Cisco-Nexus1000V-Retry-mechanism-for-VSM-REST-calls.patch
Patch0008: 0008-Sanitize-policy-profile-table-on-neutron-restart.patch
Patch0009: 0009-Enable-the-CSR1kv-devstack-plugin-for-Kilo.patch
Patch0010: 0010-Detect-switch-failure-earlier-during-port-create.patch
Patch0011: 0011-Call-to-get-nexus-type-for-Nexus-9372PX-fails.patch
Patch0012: 0012-Delete-fails-after-switch-reset-replay-off.patch
Patch0013: 0013-ML2-Nexus-decomposition-not-complete-for-Nexus.patch
Patch0014: 0014-Retry-count-not-reset-on-successful-replay.patch
Patch0015: 0015-Part-II-Detect-switch-failure-earlier-Port-Create.patch
Patch0016: 0016-ML2-cisco_nexus-MD-If-configured-close-ssh-sessions.patch
Patch0017: 0017-ML2-cisco_nexus-MD-Multiprocess-replay-issue.patch
Patch0018: 0018-Move-UCSM-from-extension-drivers-to-mech-drivers.patch
Patch0019: 0019-ML2-cisco_nexus-MD-Config-hangs-when-replay-enabled.patch
Patch0020: 0020-Update-netorking-cisco-files-for-due-to-neutrons-por.patch
Patch0021: 0021-Fix-N1kv-trunk-driver-same-mac-assigned-to-ports-cre.patch
Patch0022: 0022-Add-scripts-to-enable-CSR-FWaaS-service.patch
Patch0023: 0023-Replace-retry-count-with-replay-failure-stats.patch
Patch0024: 0024-Fix-Cisco-CSR1KV-script-issues.patch
Patch0025: 0025-Clean-up-of-UCS-Manager-connection-handle-management.patch
Patch0026: 0026-Cisco-UCSM-driver-updates-to-handle-duplicate-creati.patch
Patch0027: 0027-Remove-duplicate-entrypoints-in-setup.cfg.patch
Patch0028: 0028-Update-requirements.txt.patch
Patch0029: 0029-Update-requirements.txt-for-ML2-Nexus.patch
Patch0030: 0030-Quick-retry-connect-to-resolve-stale-ncclient-handle.patch
Patch0031: 0031-Bubble-up-exceptions-when-Nexus-replay-enabled.patch
Patch0032: 0032-Create-knob-to-prevent-caching-ssh-connection.patch
Patch0033: 0033-ML2-cisco_nexus-MD-VLAN-not-created-on-switch.patch
Patch0034: 0034-ML2-Cisco-Nexus-MD-VLAN-trunk-config-not-created-on-.patch
Patch0035: 0035-cisco-nexus-ML2-L3-agent-HA-interfaces-VLAN-not-crea.patch

BuildArch:      noarch
BuildRequires:  python2-devel
BuildRequires:  python-mock
BuildRequires:  python-neutron-tests
BuildRequires:  python-oslo-sphinx
BuildRequires:  python-pbr
BuildRequires:  python-setuptools
BuildRequires:  python-sphinx
BuildRequires:  python-testrepository
BuildRequires:  python-testtools
BuildRequires:  systemd-units

Requires:       python-babel
Requires:       python-pbr
Requires:       openstack-neutron-common
Requires:       python-UcsSdk

Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

%description
This package contains %{driver} networking driver for OpenStack Neutron.

%prep
%setup -q -n %{package_name}-%{upstream_version}

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0025 -p1
%patch0026 -p1
%patch0027 -p1
%patch0028 -p1
%patch0029 -p1
%patch0030 -p1
%patch0031 -p1
%patch0032 -p1
%patch0033 -p1
%patch0034 -p1
%patch0035 -p1

%build
%{__python2} setup.py build
%{__python2} setup.py build_sphinx
rm %{docpath}/.buildinfo

%install
export PBR_VERSION=%{version}
export SKIP_PIP_INSTALL=1
%{__python2} setup.py install --skip-build --root %{buildroot}
install -d -m 755 %{buildroot}%{_sysconfdir}/neutron/
mv %{buildroot}/usr/etc/neutron/*.ini %{buildroot}%{_sysconfdir}/neutron/

# Install systemd units
install -p -D -m 644 %{SOURCE1} %{buildroot}%{_unitdir}/neutron-cisco-cfg-agent.service

mkdir -p %{buildroot}/%{_sysconfdir}/neutron/conf.d/neutron-cisco-cfg-agent

%files
%license LICENSE
%doc README.rst
%doc %{docpath}
%{python2_sitelib}/%{srcname}
%{python2_sitelib}/*.egg-info
%config(noreplace) %attr(0640, root, neutron) %{_sysconfdir}/neutron/*.ini
%{_bindir}/neutron-cisco-cfg-agent
%{_unitdir}/neutron-cisco-cfg-agent.service

%post
%systemd_post neutron-cisco-cfg-agent.service

%preun
%systemd_preun neutron-cisco-cfg-agent.service

%postun
%systemd_postun_with_restart neutron-cisco-cfg-agent.service

%changelog
* Wed Dec 02 2015 Mike Burns <mburns@redhat.com> 2015.1.0-6
- cisco nexus ML2: L3 agent HA interfaces-VLAN not created on Nexus switch.
  rhbz#1284733

* Tue Nov 10 2015 Mike Burns <mburns@redhat.com> 2015.1.0-5
- ML2 Cisco Nexus MD: VLAN/trunk config not created on all switches rhbz#1277596

* Wed Sep 16 2015 Mike Burns <mburns@redhat.com> 2015.1.0-4
- ML2 cisco_nexus MD: VLAN not created on switch rhbz#1261555

* Thu Sep 10 2015 Mike Burns <mburns@redhat.com> 2015.1.0-3
- Create knob to prevent caching ssh connection
- Bubble up exceptions when Nexus replay enabled
- Quick retry connect to resolve stale ncclient handle

* Wed Aug 26 2015 Mike Burns <mburns@redhat.com> 2015.1.0-2
- Update requirements.txt for ML2 Nexus
- Update requirements.txt
- Remove duplicate entrypoints in setup.cfg
- Cisco UCSM driver updates to handle duplicate creations
- Clean up of UCS Manager connection handle management.
- Fix Cisco CSR1KV script issues
- Replace retry count with replay failure stats
- Add scripts to enable CSR FWaaS service
- Fix N1kv trunk driver: same mac assigned to ports created
- Update netorking-cisco files for due to neutrons port dictionary subnet being replaced with a subnets list.
- ML2 cisco_nexus MD: Config hangs when replay enabled
- Move UCSM from extension drivers to mech drivers
- ML2 cisco_nexus MD: Multiprocess replay issue
- ML2 cisco_nexus MD: If configured, close ssh sessions
- Part II-Detect switch failure earlier-Port Create
- Retry count not reset on successful replay
- ML2 Nexus decomposition not complete for Nexus
- Delete fails after switch reset (replay off)
- Call to get nexus type for Nexus 9372PX fails
- Detect switch failure earlier during port create
- Enable the CSR1kv devstack plugin for Kilo
- Sanitize policy profile table on neutron restart
- Cisco Nexus1000V: Retry mechanism for VSM REST calls
- Moved N1kv section from neutron tree to stackforge
- N1Kv: Force syncing BDs on neutron restart
- s/stackforge/openstack/g
- Bump minor version number to enable development
- Sync notification to VSM & major sync refactoring
- Revert "forcing formatting of setup.cfg to match setuptools/pbr output"

* Wed Aug 05 2015 Haïkel Guémar <hguemar@fedoraproject.org> - 2015.1.0-1
- Based upon RDO delorean package, rhbz#1254153, rhbz#1230851
